/**
 * An element which displays a single layer representing an image in the image view.
 */
angular.module('quay').directive('imageViewLayer', function () {
  var directiveDefinitionObject = {
    priority: 0,
    templateUrl: '/static/directives/image-view-layer.html',
    replace: false,
    transclude: true,
    restrict: 'C',
    scope: {
      'repository': '=repository',
      'image': '=image',
      'images': '=images'
    },
    controller: function($scope, $element, ImageMetadataService) {
      $scope.getDockerfileCommand = ImageMetadataService.getDockerfileCommand;

      $scope.getClass = function() {
        var index = $.inArray($scope.image, $scope.images);
        if (index  < 0) {
          return 'first';
        }

        if (index == $scope.images.length - 1) {
          return 'last';
        }

        return '';
      };
    }
  };
  return directiveDefinitionObject;
});