import { Input, Output, Component } from 'angular-ts-decorators';


/**
 * A component that lets the user set up a build trigger for a custom Git repository.
 */
@Component({
  selector: 'manageTriggerCustomGit',
  templateUrl: '/static/js/directives/ui/manage-trigger-custom-git/manage-trigger-custom-git.component.html'
})
export class ManageTriggerCustomGitComponent implements ng.IComponentController {

  // FIXME: Use one-way data binding
  @Input('=') public trigger: {config: any};
  @Output() public activateTrigger: (trigger: {config: any}) => void;
  private config: any = {};
  private currentState: any | null;

  public $onChanges(changes: ng.IOnChangesObject): void {
    if (changes['trigger'] !== undefined) {
      this.config = Object.assign({}, changes['trigger'].currentValue.config);
    }
  }
}
